Modal
Vue Bootstrap 5 Modal component
Use MDB modal plugin to add dialogs to your site for lightboxes, user notifications, or completely custom content.
Note: Read the API tab to find all available options and advanced customization
Basic example
Click the button to launch the modal.
<template>
<!-- Button trigger modal -->
<MDBBtn
color="primary"
aria-controls="exampleModal"
@click="exampleModal=true"
>
Launch demo modal
</MDBBtn>
<MDBModal
id="exampleModal"
tabindex="-1"
labelledby="exampleModalLabel"
v-model="exampleModal"
>
<MDBModalHeader>
<MDBModalTitle id="exampleModalLabel"> Modal title </MDBModalTitle>
</MDBModalHeader>
<MDBModalBody>...</MDBModalBody>
<MDBModalFooter>
<MDBBtn color="secondary" @click="exampleModal = false">Close</MDBBtn>
<MDBBtn color="primary">Save changes</MDBBtn>
</MDBModalFooter>
</MDBModal>
</template>
<script>
import {
MDBModal,
MDBModalHeader,
MDBModalTitle,
MDBModalBody,
MDBModalFooter,
MDBBtn,
} from 'mdb-vue-ui-kit';
import { ref } from 'vue';
export default {
components: {
MDBModal,
MDBModalHeader,
MDBModalTitle,
MDBModalBody,
MDBModalFooter,
MDBBtn,
},
setup() {
const exampleModal = ref(false);
return {
exampleModal,
};
},
};
</script>
Advanced examples
Click the buttons to launch the modals.
Frame modal

Position
Side modal

Position
Central modal

Size
How it works
Before getting started with MDB modal component, be sure to read the following as our menu options have recently changed.
-
Modals are positioned over everything else in the document and remove scroll from the
<body>
so that modal content scrolls instead. - Clicking on the modal “backdrop” will automatically close the modal.
- Bootstrap only supports one modal window at a time. Nested modals aren’t supported as we believe them to be poor user experiences.
-
Modals use
position: fixed
, which can sometimes be a bit particular about its rendering. Whenever possible, place your modal HTML in a top-level position to avoid potential interference from other elements. You’ll likely run into issues when nesting aMDBModal
within another fixed element. -
Once again, due to
position: fixed
, there are some caveats with using modals on mobile devices. -
Due to how HTML5 defines its semantics,
the
autofocus
HTML attribute has no effect in Bootstrap modals. To achieve the same effect, use some custom JavaScript:
<template>
<MDBModal v-on:shown="setFocus" v-model="show">
<MDBModalBody>
<MDBInput id="myInput" />
</MDBModalBody>
</MDBModal>
<MDBBtn @click="show = true">Open modal</MDBBtn>
</template>
<script>
import { MDBModal, MDBModalBody, MDBInput, MDBBtn } from 'mdb-vue-ui-kit';
export default {
components: {
MDBModal,
MDBModalBody,
MDBInput,
MDBBtn,
},
setup() {
function setFocus() {
const myInput = document.getElementById('myInput');
myInput.focus();
}
const show = ref(false);
return {
setFocus,
show,
};
},
};
</script>
Modal components
Below is a static MDBModal
example (meaning its
position
and display
have been overridden). Included are the
MDBModalHeader
, MDBModalBody
(required for padding
),
and MDBModalFooter
(optional). MDBModalHeader
is by default included
with dismiss action button. You can also provide another explicit dismiss action, e.g. inside
MDBModalFooter
component.
<template>
<MDBModal
tabindex="-1"
style="position: static; display: block; height: auto"
:modelValue="true"
removeBackdrop
:keyboard="false"
:focus="false"
>
<MDBModalHeader>
<MDBModalTitle>Modal title</MDBModalTitle>
</MDBModalHeader>
<MDBModalBody>
<p>Modal body text goes here.</p>
</MDBModalBody>
<MDBModalFooter>
<MDBBtn color="secondary"> Close </MDBBtn>
<MDBBtn color="primary"> Save changes </MDBBtn>
</MDBModalFooter>
</MDBModal>
</template>
<script>
import {
MDBModal,
MDBModalHeader,
MDBModalTitle,
MDBModalBody,
MDBModalFooter,
MDBBtn,
} from 'mdb-vue-ui-kit';
export default {
components: {
MDBModal,
MDBModalHeader,
MDBModalTitle,
MDBModalBody,
MDBModalFooter,
MDBBtn,
},
};
</script>
Position
To change the position of the modal add one of the following properties to the
MDBModal
Top right: side
+
position="top-right"
Top left: side
+
position="top-left"
Bottom right: side
+
position="bottom-right"
Bottom left: side
+
position="bottom-right"
Note: If you want to change the direction of modal animation, add
position="top | right | bottom | left"
property to the MDBModal
.
<template>
<!-- Button trigger modal -->
<MDBBtn
color="primary"
aria-controls="exampleSideModal1"
@click="exampleSideModal1 = true"
class="mb-2"
>
Top right
</MDBBtn>
<!-- Modal example - top right -->
<MDBModal
side
position="top-right"
direction="right"
id="exampleSideModal1"
tabindex="-1"
labelledby="exampleSideModalLabel1"
v-model="exampleSideModal1"
>
<MDBModalHeader color="info" class="text-white">
<MDBModalTitle id="exampleSideModalLabel1"> Product in the cart </MDBModalTitle>
</MDBModalHeader>
<MDBModalBody>
<MDBRow>
<MDBCol col="3" class="text-center">
<i class="fas fa-shopping-cart fa-4x text-info"></i>
</MDBCol>
<MDBCol col="9">
<p>Do you need more time to make a purchase decision?</p>
<p>No pressure, your product will be waiting for you in the cart.</p>
</MDBCol>
</MDBRow>
</MDBModalBody>
<MDBModalFooter>
<MDBBtn color="info"> Go to the cart </MDBBtn>
<MDBBtn color="outline-info" @click="exampleSideModal1 = false"> Close </MDBBtn>
</MDBModalFooter>
</MDBModal>
</template>
<script>
import {
MDBModal,
MDBModalHeader,
MDBModalTitle,
MDBModalBody,
MDBModalFooter,
MDBBtn,
MDBRow,
MDBCol,
} from 'mdb-vue-ui-kit';
import { ref } from 'vue';
export default {
components: {
MDBModal,
MDBModalHeader,
MDBModalTitle,
MDBModalBody,
MDBModalFooter,
MDBBtn,
MDBRow,
MDBCol,
},
setup() {
const exampleSideModal1 = ref(false);
return {
exampleSideModal1,
};
},
};
</script>
Frame
To make the modal "frame-like" add frame
property to the
MDBModal
element. You also need to specify the position
property
with bottom
or top
values.
<template>
<!-- Button trigger modal -->
<MDBBtn
color="primary"
aria-controls="exampleFrameModal1"
@click="exampleFrameModal1 = true"
class="mb-2"
>
Top
</MDBBtn>
<!-- Modal frame top example -->
<MDBModal
frame
position="top"
id="exampleFrameModal1"
tabindex="-1"
labelledby="exampleFrameModal1"
v-model="exampleFrameModal1"
>
<MDBModalBody class="py-1">
<div class="d-flex justify-content-center align-items-center my-3">
<h4>
<MDBBadge color="primary">v52gs1</MDBBadge>
</h4>
<p class="pt-3 mx-4">
We have a gift for you! Use this code to get a
<strong>10% discount</strong>.
</p>
<MDBBtn color="primary" size="sm" class="ms-2"> Use it </MDBBtn>
<MDBBtn color="info" size="sm" @click="exampleFrameModal1 = false">
No, thanks
</MDBBtn>
</div>
</MDBModalBody>
</MDBModal>
<!-- Modal frame top example-->
</template>
<script>
import {
MDBModal,
MDBModalBody,
MDBBtn,
MDBBadge
} from "mdb-vue-ui-kit";
import { ref } from 'vue';
export default {
components: {
MDBModal,
MDBModalBody,
MDBBtn,
MDBBadge
},
setup() {
const exampleFrameModal1 = ref(false);
return {
exampleFrameModal1
}
}
};
</script>
Static backdrop
When staticBackdrop
property is added to MDBModal
, the modal will
not close when clicking outside it. Click the button below to try it.
<template>
<!-- Button trigger modal -->
<MDBBtn
color="primary"
aria-controls="staticBackdropLabel"
@click="staticBackdrop = true"
>
Launch static backdrop modal
</MDBBtn>
<!-- Modal -->
<MDBModal
id="staticBackdrop"
tabindex="-1"
labelledby="staticBackdropLabel"
v-model="staticBackdrop"
staticBackdrop
>
<MDBModalHeader>
<MDBModalTitle id="staticBackdropLabel"> Modal title </MDBModalTitle>
</MDBModalHeader>
<MDBModalBody>...</MDBModalBody>
<MDBModalFooter>
<MDBBtn color="secondary" @click="staticBackdrop = false"> Close </MDBBtn>
<MDBBtn color="primary"> Understood </MDBBtn>
</MDBModalFooter>
</MDBModal>
</template>
<script>
import {
MDBModal,
MDBModalHeader,
MDBModalTitle,
MDBModalBody,
MDBModalFooter,
MDBBtn,
} from 'mdb-vue-ui-kit';
import { ref } from 'vue';
export default {
components: {
MDBModal,
MDBModalHeader,
MDBModalTitle,
MDBModalBody,
MDBModalFooter,
MDBBtn,
},
setup() {
const staticBackdrop = ref(false);
return {
staticBackdrop,
};
},
};
</script>
Scrolling long content
When modals become too long for the user’s viewport or device, they scroll independent of the page itself. Try the demo below to see what we mean.
You can also create a scrollable modal that allows scroll the modal body by adding
scrollable
property to MDBModal
.
<template>
<MDBBtn
color="primary"
aria-controls="exampleModalLongTitle"
@click="exampleModalLong = true"
>
Launch demo modal
</MDBBtn>
<MDBModal
class="modal fade"
id="exampleModalLong"
tabindex="-1"
labelledby="exampleModalLongTitle"
v-model="exampleModalLong"
>
<MDBModalHeader>
<MDBModalTitle id="exampleModalLongTitle"> Modal title </MDBModalTitle>
</MDBModalHeader>
<MDBModalBody> ... long body </MDBModalBody>
<MDBModalFooter>
<MDBBtn color="secondary" @click="exampleModalLong = false"> Close </MDBBtn>
<MDBBtn color="primary"> Save changes </MDBBtn>
</MDBModalFooter>
</MDBModal>
<MDBBtn
color="primary"
aria-controls="exampleModalScrollableTitle"
@click="exampleModalScrollable = true"
>
Launch demo modal
</MDBBtn>
<MDBModal
id="exampleModalScrollable"
tabindex="-1"
labelledby="exampleModalScrollableTitle"
v-model="exampleModalScrollable"
scrollable
>
<MDBModalHeader>
<MDBModalTitle id="exampleModalScrollableTitle"> Modal title </MDBModalTitle>
</MDBModalHeader>
<MDBModalBody> ... long content </MDBModalBody>
<MDBModalFooter>
<MDBBtn color="secondary" @click="exampleModalScrollable = false"> Close </MDBBtn>
<MDBBtn color="primary"> Save changes </MDBBtn>
</MDBModalFooter>
</MDBModal>
</template>
<script>
import {
MDBModal,
MDBModalHeader,
MDBModalTitle,
MDBModalBody,
MDBModalFooter,
MDBBtn,
} from 'mdb-vue-ui-kit';
import { ref } from 'vue';
export default {
components: {
MDBModal,
MDBModalHeader,
MDBModalTitle,
MDBModalBody,
MDBModalFooter,
MDBBtn,
},
setup() {
const exampleModalLong = ref(false);
const exampleModalScrollable = ref(false);
return {
exampleModalScrollable,
exampleModalLong,
};
},
};
</script>
Vertically centered
Add centered
to MDBModal
to vertically center the modal.
<template>
<MDBBtn
color="primary"
aria-controls="exampleModalCenter"
@click="exampleModalCenter = true"
>
Vertically centered modal
</MDBBtn>
<MDBModal
id="exampleModalCenter"
tabindex="-1"
labelledby="exampleModalCenterTitle"
v-model="exampleModalCenter"
centered
>
<MDBModalHeader>
<MDBModalTitle id="exampleModalCenterTitle"> Modal title </MDBModalTitle>
</MDBModalHeader>
<MDBModalBody>
<p>
Cras mattis consectetur purus sit amet fermentum. Cras justo odio, dapibus ac
facilisis in, egestas eget quam. Morbi leo risus, porta ac consectetur ac,
vestibulum at eros.
</p>
</MDBModalBody>
<MDBModalFooter>
<MDBBtn color="secondary" @click="exampleModalCenter = false"> Close </MDBBtn>
<MDBBtn color="primary"> Save changes </MDBBtn>
</MDBModalFooter>
</MDBModal>
<MDBBtn
color="primary"
aria-controls="exampleModalCenteredScrollable"
@click="exampleModalCenteredScrollable = true"
>
Vertically centered scrollable modal
</MDBBtn>
<MDBModal
id="exampleModalCenteredScrollable"
tabindex="-1"
labelledby="exampleModalCenteredScrollableTitle"
v-model="exampleModalCenteredScrollable"
centered
scrollable
>
<MDBModalHeader>
<MDBModalTitle id="exampleModalCenteredScrollableTitle">
Modal title
</MDBModalTitle>
</MDBModalHeader>
<MDBModalBody> ... long content </MDBModalBody>
<MDBModalFooter>
<MDBBtn color="secondary" @click="exampleModalCenteredScrollable = false">
Close
</MDBBtn>
<MDBBtn color="primary"> Save changes </MDBBtn>
</MDBModalFooter>
</MDBModal>
</template>
<script>
import {
MDBModal,
MDBModalHeader,
MDBModalTitle,
MDBModalBody,
MDBModalFooter,
MDBBtn,
} from 'mdb-vue-ui-kit';
import { ref } from 'vue';
export default {
components: {
MDBModal,
MDBModalHeader,
MDBModalTitle,
MDBModalBody,
MDBModalFooter,
MDBBtn,
},
setup() {
const exampleModalCenteredScrollable = ref(false);
return {
exampleModalCenteredScrollable,
};
},
};
</script>
Tooltips and popovers
Tooltips and
popovers can be placed within modals as
needed. You can add function on hide
event to manually close any opened popover
or tooltip when closing modal.
<template>
<MDBBtn
color="primary"
aria-controls="exampleModalPopovers"
@click="exampleModalPopovers = true"
>
Launch demo modal
</MDBBtn>
<MDBModal
id="exampleModalPopovers"
tabindex="-1"
labelledby="exampleModalPopoversLabel"
v-model="exampleModalPopovers"
@hide="
() => {
popover1 = false;
tooltip1 = false;
}
"
>
<MDBModalHeader>
<MDBModalTitle id="exampleModalPopoversLabel"> Modal title </MDBModalTitle>
</MDBModalHeader>
<MDBModalBody>
<h5>Popover in a modal</h5>
<p>
This
<MDBPopover v-model="popover1" direction="right">
<template #reference>
<MDBBtn color="secondary" size="lg" @click="popover1 = !popover1"
>button</MDBBtn
>
</template>
<template #header>Popover title</template>
<template #body>Popover body content is set in this attribute.</template>
</MDBPopover>
triggers a popover on click.
</p>
<hr />
<h5>Tooltips in a modal</h5>
<p>
<MDBTooltip v-model="tooltip1">
<template #reference><a href="#">This link</a></template>
<template #tip> Tooltip </template>
</MDBTooltip>
and
<MDBTooltip v-model="tooltip2">
<template #reference><a href="#">that link</a></template>
<template #tip> Tooltip </template>
</MDBTooltip>
have tooltips on hover.
</p></MDBModalBody
>
<MDBModalFooter>
<MDBBtn color="secondary" @click="exampleModalPopovers = false"> Close </MDBBtn>
<MDBBtn color="primary"> Save changes </MDBBtn>
</MDBModalFooter>
</MDBModal>
</template>
<script>
import {
MDBModal,
MDBModalHeader,
MDBModalTitle,
MDBModalBody,
MDBModalFooter,
MDBBtn,
MDBPopover,
MDBTooltip,
} from 'mdb-vue-ui-kit';
import { ref } from 'vue';
export default {
components: {
MDBModal,
MDBModalHeader,
MDBModalTitle,
MDBModalBody,
MDBModalFooter,
MDBBtn,
MDBPopover,
MDBTooltip,
},
setup() {
const exampleModalPopovers = ref(false);
const popover1 = ref(false);
const tooltip1 = ref(false);
const tooltip2 = ref(false);
return {
exampleModalPopovers,
popover1,
tooltip1,
tooltip2,
};
},
};
</script>
Using the grid
Utilize the Bootstrap grid system within a modal by nesting
MDBContainer fluid{
within the MDBModalBody{
. Then, use the normal
grid system properties/classes as you would anywhere else.
<template>
<MDBBtn color="primary" aria-controls="gridSystemModal" @click="gridSystemModal = true">
Launch demo modal
</MDBBtn>
<MDBModal
id="gridSystemModal"
tabindex="-1"
labelledby="gridModalLabel"
v-model="gridSystemModal"
>
<MDBModalHeader>
<MDBModalTitle id="gridModalLabel"> Grids in modals </MDBModalTitle>
</MDBModalHeader>
<MDBModalBody>
<MDBContainer fluid class="bd-example-row">
<MDBRow>
<MDBCol md="4" class="col-example">md="4"</MDBCol>
<MDBCol md="4" class="ms-auto col-example"> md="4" .ms-auto </MDBCol>
</MDBRow>
<MDBRow>
<MDBCol md="3" class="ms-auto col-example"> md="3" .ms-auto </MDBCol>
<MDBCol md="2" class="ms-auto col-example"> md="2" .ms-auto </MDBCol>
</MDBRow>
<MDBRow>
<MDBCol md="6" class="ms-auto col-example"> md="6" .ms-auto </MDBCol>
</MDBRow>
<MDBRow>
<MDBCol sm="9" class="col-example">
Level 1: sm="9"
<MDBRow>
<MDBCol col="8" sm="6" class="col-example">
Level 2: col="8" sm="6"
</MDBCol>
<MDBCol col="4" sm="6" class="col-example">
Level 2: col="4" sm="6"
</MDBCol>
</MDBRow>
</MDBCol>
</MDBRow>
</MDBContainer>
</MDBModalBody>
<MDBModalFooter>
<MDBBtn color="secondary" @click="gridSystemModal = false"> Close </MDBBtn>
<MDBBtn color="primary"> Save changes </MDBBtn>
</MDBModalFooter>
</MDBModal>
</template>
<script>
import {
MDBModal,
MDBModalHeader,
MDBModalTitle,
MDBModalBody,
MDBModalFooter,
MDBBtn,
} from 'mdb-vue-ui-kit';
import { ref } from 'vue';
export default {
components: {
MDBModal,
MDBModalHeader,
MDBModalTitle,
MDBModalBody,
MDBModalFooter,
MDBBtn,
},
setup() {
const gridSystemModal = ref(false);
return {
gridSystemModal,
};
},
};
</script>
Varying modal content
Have a bunch of buttons that all trigger the same modal with slightly different contents? Use
Vue
refs
to vary the contents of the modal depending on which button was clicked.
Below is a live demo followed by example Vue template and script.
<template>
<MDBBtn
color="primary"
aria-controls="varyingExampleModal"
@click="
() => {
modalContent = '@mdo';
varyingExampleModal = true;
}
"
>
Open modal for @mdo
</MDBBtn>
<MDBBtn
color="primary"
aria-controls="varyingExampleModal"
@click="
() => {
modalContent = '@fat';
varyingExampleModal = true;
}
"
>
Open modal for @fat
</MDBBtn>
<MDBBtn
color="primary"
aria-controls="varyingExampleModal"
@click="
() => {
modalContent = '@getbootstrap';
varyingExampleModal = true;
}
"
>
Open modal for @getbootstrap
</MDBBtn>
<MDBModal
id="varyingExampleModal"
tabindex="-1"
labelledby="varyingExampleModalLabel"
v-model="varyingExampleModal"
>
<MDBModalHeader>
<MDBModalTitle id="varyingExampleModalLabel"> New message </MDBModalTitle>
</MDBModalHeader>
<MDBModalBody>
<form>
<div class="mb-3">
<label for="recipient-name" class="col-form-label">Recipient: </label>
<input
type="text"
class="form-control"
id="recipient-name"
:value="modalContent"
/>
</div>
<div class="mb-3">
<label for="message-text" class="col-form-label">Message:</label>
<textarea class="form-control" id="message-text"></textarea>
</div>
</form>
</MDBModalBody>
<MDBModalFooter>
<MDBBtn color="secondary" @click="varyingExampleModal = false"> Close </MDBBtn>
<MDBBtn color="primary"> Send message </MDBBtn>
</MDBModalFooter>
</MDBModal>
</template>
<script>
import { MDBModal, MDBModalHeader, MDBModalTitle, MDBModalBody, MDBModalFooter, MDBBtn } from "mdb-vue-ui-kit";
import { ref } from 'vue';
export default {
components: {
MDBModal,
MDBModalHeader,
MDBModalTitle,
MDBModalBody,
MDBModalFooter,
MDBBtn
},
setup() {
const varyingExampleModal = ref(false);
const modalContent = ref('');
return {
varyingExampleModal,
modalContent,
}
}
};
</script>
Toggle between modals
Toggle between multiple modals with some clever placement of the
data-mdb-target
and data-mdb-toggle
attributes. For example, you
could toggle a password reset modal from within an already open sign in modal.
Please note multiple modals cannot be open at the same time—this method
simply toggles between two separate modals.
Below is a live demo followed by example HTML and JavaScript. For more information, read the
modal API/events doc for details on relatedTarget
.
<template>
<MDBBtn color="primary" @click="exampleModalToggle1 = true">Open first modal</MDBBtn>
<MDBModal id="exampleModalToggle1" tabindex="-1" labelledby="exampleModalToggle1Label" v-model="exampleModalToggle1">
<MDBModalHeader>
<MDBModalTitle id="exampleModalToggle1Label">
Modal 1</MDBModalTitle>
</MDBModalHeader>
<MDBModalBody>Show a second modal and hide this one with the button
below.</MDBModalBody>
<MDBModalFooter>
<MDBBtn color="primary" @click="openSecondModal">Open second modal</MDBBtn>
</MDBModalFooter>
</MDBModal>
<MDBModal id="exampleModalToggle2" tabindex="-1" labelledby="exampleModalToggle2Label" v-model="exampleModalToggle2">
<MDBModalHeader>
<MDBModalTitle id="exampleModalToggle2Label">
Modal 1</MDBModalTitle>
</MDBModalHeader>
<MDBModalBody>Hide this modal and show the first with the button
below.</MDBModalBody>
<MDBModalFooter>
<MDBBtn color="primary" @click="openFirstModal">Back to first</MDBBtn>
</MDBModalFooter>
</MDBModal>
</template>
<script>
import { MDBModal, MDBModalHeader, MDBModalTitle, MDBModalBody, MDBModalFooter, MDBBtn } from "mdb-vue-ui-kit";
import { ref } from 'vue';
export default {
components: {
MDBModal,
MDBModalHeader,
MDBModalTitle,
MDBModalBody,
MDBModalFooter,
MDBBtn
},
setup() {
const exampleModalToggle1 = ref(false);
const exampleModalToggle1 = ref(false);
const openSecondModal = () => {
exampleModalToggle1.value = false;
setTimeout(() => {
exampleModalToggle2.value = true;
}, 200);
};
const openFirstModal = () => {
exampleModalToggle2.value = false;
setTimeout(() => {
exampleModalToggle1.value = true;
}, 200);
};
return {
exampleModalToggle1,
exampleModalToggle2,
openSecondModal,
openFirstModal
}
}
};
</script>
Change animation
The $modal-fade-transform
variable determines the transform state of
modal dialog
content before the modal fade-in animation, the
$modal-show-transform
variable determines the transform of
.modal-dialog
at the end of the modal fade-in animation.
If you want for example a zoom-in animation, you can set
$modal-fade-transform: scale(.8)
.
Remove animation
For modals that simply appear rather than fade in to view, add the
:animation="false"
property to your modal markup.
<template>
<MDBModal tabindex="-1" labelledby="..." v-model="..." :animation="false" />
</template>
Accessibility
Be sure to add labelledby="..."
>, referencing the modal title, to
MDBModal
>. Additionally, you may give a description of your modal dialog with
aria-describedby
> on MDBModal
>. Note that you don’t need to add
role="dialog"
> since we already add it inside component.
Embedding YouTube videos
Embedding YouTube videos in modals requires additional JavaScript not in Bootstrap to automatically stop playback and more. See this helpful Stack Overflow post for more information.
Optional sizes
Modals have three optional sizes, available via modifier properties to be placed on a
MDBModal
. These sizes kick in at certain breakpoints to avoid horizontal
scrollbars on narrower viewports.
Size | Property | Modal max-width |
---|---|---|
Small | size="sm" |
300px |
Default | None | 500px |
Large | size="lg" |
800px |
Extra large | size="xl" |
1140px |
<template>
<MDBModal size="xl">...</MDBModal>
<MDBModal size="lg">...</MDBModal>
<MDBModal size="sm">...</MDBModal>
</template>
Fullscreen Modal
Another override is the option to pop up a modal that covers the user viewport, available via
fullscreen
properties that are placed on a MDBModal
.
Class | Availability |
---|---|
fullscreen |
Always |
fullscreen="sm-down" |
Below 576px |
fullscreen="md-down" |
Below 768px |
fullscreen="lg-down" |
Below 992px |
fullscreen="xl-down" |
Below 1200px |
fullscreen="xxl-down" |
Below 1400px |
<!-- Full screen modal -->
<template>
<MDBModal fullscreen>...</MDBModal>
<MDBModal fullscreen="sm-down">...</MDBModal>
<MDBModal fullscreen="md-down">...</MDBModal>
<MDBModal fullscreen="lg-down">...</MDBModal>
<MDBModal fullscreen="xl-down">...</MDBModal>
<MDBModal fullscreen="xxl-down">...</MDBModal>
</template>
Modal - API
Import
<script>
import {
MDBModal,
MDBModalBody,
MDBModalHeader,
MDBModalTitle,
MDBModalFooter
} from 'mdb-vue-ui-kit';
</script>
Properties
Modal
Name | Type | Default | Description | Example |
---|---|---|---|---|
animation
|
Boolean | true |
Turn modal animation on or off |
<MDBModal :animation="false" />
|
bgSrc
|
String | -- |
Dark style necessitate having a picture background, but the feature is for all the modals, really |
<MDBModal bgSrc="/image/src" />
|
centered
|
Boolean | false |
Center modal vertically and horizonally |
<MDBModal centered />
|
duration
|
Number | 400 |
Sets animation duration in miliseconds |
<MDBModal :duration="500" />
|
focus
|
Boolean | true |
Puts the focus on the modal when initialized. |
<MDBModal :focus="false" />
|
fullscreen
|
Number | 400 |
Makes the modal cover user viewport on a specific breakpoint |
<MDBModal :fullscreen="lg-down" />
|
keyboard
|
Boolean | true |
Closes the modal when escape key is pressed |
<MDBModal :keyboard="false" />
|
labelledby
|
String | -- |
When having modal content with the title add labelledby to make modal
more accessible
|
<MDBModal labelledby="modalExampleTitle">
<MDBModalHeader>
<MDBModalTitle tag="h4" id="modalExampleTitle">
Modal title
</MDBModalTitle>
</MDBModalHeader>
</MDBModal>
|
removeBackdrop
|
Boolean | false |
Removes the dark overlay from the background, along its functionality |
<MDBModal removeBackdrop />
|
scrollable
|
Boolean | false |
Allows to scroll through long contents with a scrollbar |
<MDBModal scrollable />
|
size
|
String | -- |
Sets size of MDBModal component. Use "sm | lg | xl" values |
<MDBModal size="sm" /> |
staticBackdrop
|
Boolean | false |
Will prevent modal close when clicking outside the backdrop |
<MDBModal staticBackdrop />
|
tag
|
String | 'div' |
Defines tag of the MDBModal element |
<MDBModal tag="span" />
|
v-model
|
String | false |
Opens / closes modal component |
<MDBModal v-model="true" />
|
Modal Header
Name | Type | Default | Description | Example |
---|---|---|---|---|
tag
|
String | 'div' |
Defines tag of the MDBModalHeader element |
<MDBModalHeader tag="header" />
|
close
|
Boolean | true |
Turning it to false removes the close "x" icon in the right top corner |
<MDBModalHeader :close="false" />
|
closeWhite
|
Boolean | false |
Makes the closing "x" sign works better with dark variant of the modal |
<MDBModalHeader :closeWhite />
|
color
|
String | -- |
Determines color of the header |
<MDBModalHeader color="secondary" />
|
Modal Title
Name | Type | Default | Description | Example |
---|---|---|---|---|
tag
|
String | 'h5' |
Defines tag of the MDBModalTitle element |
<MDBModalTitle tag="h6" />
|
bold
|
Boolean | false |
Makes title font bold |
<MDBModalTitle bold />
|
Events
Bootstrap’s modal class exposes a few events for hooking into modal functionality. All modal
events are fired at the modal itself (i.e. at the
<div class="modal">
).
Event type | Description |
---|---|
show |
This event fires immediately when the modal has been called to show. |
shown |
This event is fired when the modal has been made visible to the user (will wait for CSS transitions to complete). |
hide |
This event is fired immediately when the modal has been called to hide. |
hidden |
This event is fired when the modal has finished being hidden from the user (will wait for CSS transitions to complete). |

Modal
React Bootstrap 5 Modal component
Use MDB modal plugin to add dialogs to your site for lightboxes, user notifications, or completely custom content.
Note: Read the API tab to find all available options and advanced customization
Basic example
Click the button to launch the modal.
import React, { useState } from 'react';
import { MDBBtn,
MDBModal,
MDBModalDialog,
MDBModalContent,
MDBModalHeader,
MDBModalTitle,
MDBModalBody,
MDBModalFooter,
} from 'mdb-react-ui-kit';
export default function App() {
const [basicModal, setBasicModal] = useState(false);
const toggleShow = () => setBasicModal(!basicModal);
return (
<>
<MDBBtn onClick={toggleShow}>LAUNCH DEMO MODAL</MDBBtn>
<MDBModal show={basicModal} setShow={setBasicModal} tabIndex='-1'>
<MDBModalDialog>
<MDBModalContent>
<MDBModalHeader>
<MDBModalTitle>Modal title</MDBModalTitle>
<MDBBtn className='btn-close' color='none' onClick={toggleShow}></MDBBtn>
</MDBModalHeader>
<MDBModalBody>...</MDBModalBody>
<MDBModalFooter>
<MDBBtn color='secondary' onClick={toggleShow}>
Close
</MDBBtn>
<MDBBtn>Save changes</MDBBtn>
</MDBModalFooter>
</MDBModalContent>
</MDBModalDialog>
</MDBModal>
</>
);
}
Advanced examples
Click the buttons to launch the modals.
Frame modal

Position
Side modal

Position
Central modal

Size
Modal components
Below is a static modal example (meaning its position
and
display
have been overridden). Included are the modal header, modal body
(required for padding
), and modal footer (optional). We ask that you include
modal headers with dismiss actions whenever possible, or provide another explicit dismiss
action.
import React, { useState } from 'react';
import { MDBBtn,
MDBModal,
MDBModalDialog,
MDBModalContent,
MDBModalHeader,
MDBModalTitle,
MDBModalBody,
MDBModalFooter,
} from 'mdb-react-ui-kit';
export default function App() {
const [basicModal, setBasicModal] = useState(false);
const toggleShow = () => setBasicModal(!basicModal);
return (
<>
<MDBBtn onClick={toggleShow}>LAUNCH DEMO MODAL</MDBBtn>
<MDBModal show={basicModal} setShow={setBasicModal} tabIndex='-1'>
<MDBModalDialog>
<MDBModalContent>
<MDBModalHeader>
<MDBModalTitle>Modal title</MDBModalTitle>
<MDBBtn className='btn-close' color='none' onClick={toggleShow}></MDBBtn>
</MDBModalHeader>
<MDBModalBody>Modal body text goes here.</MDBModalBody>
<MDBModalFooter>
<MDBBtn color='secondary' onClick={toggleShow}>
Close
</MDBBtn>
<MDBBtn>Save changes</MDBBtn>
</MDBModalFooter>
</MDBModalContent>
</MDBModalDialog>
</MDBModal>
</>
);
}
Position
To change the position of the modal add one of the following props to the MDBModalDialog
Top right:
side
+ position="top-right"
Top left:
side
+ position="top-left"
Bottom right:
side
+ position="bottom-right"
Bottom left:
side
+ position="bottom-left"
Note: If you want to change the direction of modal animation, add the prop{' '}
animationDirection
, top
, bottom
or left
to the{' '}
Modal
component.
import React, { useState } from 'react';
import { MDBBtn,
MDBModal,
MDBModalDialog,
MDBModalContent,
MDBModalHeader,
MDBModalTitle,
MDBModalBody,
MDBModalFooter,
} from 'mdb-react-ui-kit';
export default function App() {
const [topRightModal, setTopRightModal] = useState(false);
const toggleShow = () => setTopRightModal(!topRightModal);
return (
<>
<MDBBtn onClick={toggleShow}>Top right</MDBBtn>
<MDBModal
animationDirection='right'
show={topRightModal}
tabIndex='-1'
setShow={setTopRightModal}
>
<MDBModalDialog position='top-right' side>
<MDBModalContent>
<MDBModalHeader className='bg-info text-white'>
<MDBModalTitle>Product in the cart</MDBModalTitle>
<MDBBtn
color='none'
className='btn-close btn-close-white'
onClick={toggleShow}
></MDBBtn>
</MDBModalHeader>
<MDBModalBody>
<div className='row'>
<div className='col-3 text-center'>
<i className='fas fa-shopping-cart fa-4x text-info'></i>
</div>
<div className='col-9'>
<p>Do you need more time to make a purchase decision?</p>
<p>No pressure, your product will be waiting for you in the cart.</p>
</div>
</div>
</MDBModalBody>
<MDBModalFooter>
<MDBBtn color='info'>Go to the cart</MDBBtn>
<MDBBtn outline color='info' onClick={toggleShow}>
Close
</MDBBtn>
</MDBModalFooter>
</MDBModalContent>
</MDBModalDialog>
</MDBModal>
</>
);
}
Frame
To make the modal "frame-like" add frame
prop to the
MDBModalDialog
element. You also need to specify the direction by adding
position="bottom"
or position="top"
to the MDBModalDialog
.
import React, { useState } from 'react';
import { MDBBtn,
MDBModal,
MDBModalDialog,
MDBModalContent,
MDBModalHeader,
MDBModalTitle,
MDBModalBody,
MDBModalFooter,
} from 'mdb-react-ui-kit';
export default function App() {
const [bottomModal, setBottomModal] = useState(false);
const toggleShow = () => setBottomModal(!bottomModal);
return (
<>
<MDBBtn onClick={toggleShow}>Launch frame modal</MDBBtn>
<MDBModal
animationDirection='bottom'
show={bottomModal}
tabIndex='-1'
setShow={setBottomModal}
>
<MDBModalDialog position='bottom' frame>
<MDBModalContent>
<MDBModalBody className='py-1'>
<div className='d-flex justify-content-center align-items-center my-3'>
<p className='mb-0'>We use cookies to improve your website experience</p>
<MDBBtn color='success' size='sm' className='ms-2' onClick={toggleShow}>
Ok, thanks
</MDBBtn>
<MDBBtn size='sm' className='ms-2'>
Learn more
</MDBBtn>
</div>
</MDBModalBody>
</MDBModalContent>
</MDBModalDialog>
</MDBModal>
</>
);
}
Static backdrop
When backdrop is set to static, the modal will not close when clicking outside it. Click the button below to try it.
import React, { useState } from 'react';
import { MDBBtn,
MDBModal,
MDBModalDialog,
MDBModalContent,
MDBModalHeader,
MDBModalTitle,
MDBModalBody,
MDBModalFooter,
} from 'mdb-react-ui-kit';
export default function App() {
const [staticModal, setStaticModal] = useState(false);
const toggleShow = () => setStaticModal(!staticModal);
return (
<>
<MDBBtn onClick={toggleShow}>Launch static backdrop modal</MDBBtn>
<MDBModal staticBackdrop tabIndex='-1' show={staticModal} setShow={setStaticModal}>
<MDBModalDialog>
<MDBModalContent>
<MDBModalHeader>
<MDBModalTitle>Modal title</MDBModalTitle>
<MDBBtn className='btn-close' color='none' onClick={toggleShow}></MDBBtn>
</MDBModalHeader>
<MDBModalBody>...</MDBModalBody>
<MDBModalFooter>
<MDBBtn color='secondary' onClick={toggleShow}>
Close
</MDBBtn>
<MDBBtn>Understood</MDBBtn>
</MDBModalFooter>
</MDBModalContent>
</MDBModalDialog>
</MDBModal>
</>
);
}
Scrolling long content
When modals become too long for the user’s viewport or device, they scroll independent of the page itself. Try the demo below to see what we mean.
You can also create a scrollable modal that allows scroll the modal body by adding
scrollable
to MDBModalDialog
.
import React, { useState } from 'react';
import { MDBBtn,
MDBModal,
MDBModalDialog,
MDBModalContent,
MDBModalHeader,
MDBModalTitle,
MDBModalBody,
MDBModalFooter,
} from 'mdb-react-ui-kit';
export default function App() {
const [scrollableModal, setScrollableModal] = useState(false);
return (
<>
<MDBBtn onClick={() => setScrollableModal(!scrollableModal)}>LAUNCH DEMO MODAL</MDBBtn>
<MDBModal show={scrollableModal} setShow={setScrollableModal} tabIndex='-1'>
<MDBModalDialog scrollable>
<MDBModalContent>
<MDBModalHeader>
<MDBModalTitle>Modal title</MDBModalTitle>
<MDBBtn
className='btn-close'
color='none'
onClick={() => setScrollableModal(!scrollableModal)}
></MDBBtn>
</MDBModalHeader>
<MDBModalBody>
<p>
Cras mattis consectetur purus sit amet fermentum. Cras justo odio, dapibus ac facilisis in,
egestas eget quam. Morbi leo risus, porta ac consectetur ac, vestibulum at eros.
</p>
<p>
Praesent commodo cursus magna, vel scelerisque nisl consectetur et. Vivamus sagittis lacus vel
augue laoreet rutrum faucibus dolor auctor.
</p>
<p>
Aenean lacinia bibendum nulla sed consectetur. Praesent commodo cursus magna, vel scelerisque nisl
consectetur et. Donec sed odio dui. Donec ullamcorper nulla non metus auctor fringilla.
</p>
<p>
Cras mattis consectetur purus sit amet fermentum. Cras justo odio, dapibus ac facilisis in,
egestas eget quam. Morbi leo risus, porta ac consectetur ac, vestibulum at eros.
</p>
<p>
Praesent commodo cursus magna, vel scelerisque nisl consectetur et. Vivamus sagittis lacus vel
augue laoreet rutrum faucibus dolor auctor.
</p>
<p>
Aenean lacinia bibendum nulla sed consectetur. Praesent commodo cursus magna, vel scelerisque nisl
consectetur et. Donec sed odio dui. Donec ullamcorper nulla non metus auctor fringilla.
</p>
<p>
Cras mattis consectetur purus sit amet fermentum. Cras justo odio, dapibus ac facilisis in,
egestas eget quam. Morbi leo risus, porta ac consectetur ac, vestibulum at eros.
</p>
<p>
Praesent commodo cursus magna, vel scelerisque nisl consectetur et. Vivamus sagittis lacus vel
augue laoreet rutrum faucibus dolor auctor.
</p>
<p>
Aenean lacinia bibendum nulla sed consectetur. Praesent commodo cursus magna, vel scelerisque nisl
consectetur et. Donec sed odio dui. Donec ullamcorper nulla non metus auctor fringilla.
</p>
<p>
Cras mattis consectetur purus sit amet fermentum. Cras justo odio, dapibus ac facilisis in,
egestas eget quam. Morbi leo risus, porta ac consectetur ac, vestibulum at eros.
</p>
<p>
Praesent commodo cursus magna, vel scelerisque nisl consectetur et. Vivamus sagittis lacus vel
augue laoreet rutrum faucibus dolor auctor.
</p>
<p>
Aenean lacinia bibendum nulla sed consectetur. Praesent commodo cursus magna, vel scelerisque nisl
consectetur et. Donec sed odio dui. Donec ullamcorper nulla non metus auctor fringilla.
</p>
<p>
Cras mattis consectetur purus sit amet fermentum. Cras justo odio, dapibus ac facilisis in,
egestas eget quam. Morbi leo risus, porta ac consectetur ac, vestibulum at eros.
</p>
<p>
Praesent commodo cursus magna, vel scelerisque nisl consectetur et. Vivamus sagittis lacus vel
augue laoreet rutrum faucibus dolor auctor.
</p>
<p>
Aenean lacinia bibendum nulla sed consectetur. Praesent commodo cursus magna, vel scelerisque nisl
consectetur et. Donec sed odio dui. Donec ullamcorper nulla non metus auctor fringilla.
</p>
<p>
Cras mattis consectetur purus sit amet fermentum. Cras justo odio, dapibus ac facilisis in,
egestas eget quam. Morbi leo risus, porta ac consectetur ac, vestibulum at eros.
</p>
<p>
Praesent commodo cursus magna, vel scelerisque nisl consectetur et. Vivamus sagittis lacus vel
augue laoreet rutrum faucibus dolor auctor.
</p>
<p>
Aenean lacinia bibendum nulla sed consectetur. Praesent commodo cursus magna, vel scelerisque nisl
consectetur et. Donec sed odio dui. Donec ullamcorper nulla non metus auctor fringilla.
</p>
</MDBModalBody>
<MDBModalFooter>
<MDBBtn color='secondary' onClick={() => setScrollableModal(!setScrollableModal)}>
Close
</MDBBtn>
<MDBBtn>Save changes</MDBBtn>
</MDBModalFooter>
</MDBModalContent>
</MDBModalDialog>
</MDBModal>
</>
);
}
Vertically centered
Add centered
to MDBModalDialog
to vertically center the modal.
import React, { useState } from 'react';
import { MDBBtn,
MDBModal,
MDBModalDialog,
MDBModalContent,
MDBModalHeader,
MDBModalTitle,
MDBModalBody,
MDBModalFooter,
} from 'mdb-react-ui-kit';
export default function App() {
const [centredModal, setCentredModal] = useState(false);
const toggleShow = () => setCentredModal(!centredModal);
return (
<>
<MDBBtn onClick={toggleShow}>Vertically centered modal</MDBBtn>
<MDBModal tabIndex='-1' show={centredModal} setShow={setCentredModal}>
<MDBModalDialog centered>
<MDBModalContent>
<MDBModalHeader>
<MDBModalTitle>Modal title</MDBModalTitle>
<MDBBtn className='btn-close' color='none' onClick={toggleShow}></MDBBtn>
</MDBModalHeader>
<MDBModalBody>
<p>
Cras mattis consectetur purus sit amet fermentum. Cras justo odio, dapibus ac facilisis in,
egestas eget quam. Morbi leo risus, porta ac consectetur ac, vestibulum at eros.
</p>
</MDBModalBody>
<MDBModalFooter>
<MDBBtn color='secondary' onClick={toggleShow}>
Close
</MDBBtn>
<MDBBtn>Save changes</MDBBtn>
</MDBModalFooter>
</MDBModalContent>
</MDBModalDialog>
</MDBModal>
</>
);
}
Tooltips and popovers
Tooltips and popovers can be placed within modals as needed. When modals are closed, any tooltips and popovers within are also automatically dismissed.
import React, { useState } from 'react';
import {
MDBBtn,
MDBModal,
MDBModalDialog,
MDBModalContent,
MDBModalHeader,
MDBModalTitle,
MDBModalBody,
MDBModalFooter,
MDBPopover,
MDBPopoverHeader,
MDBPopoverBody,
MDBTooltip
} from 'mdb-react-ui-kit';
export default function App() {
const [popoverModal, setPopoverModal] = useState(false);
const toggleShow = () => setPopoverModal(!popoverModal);
return (
<>
<MDBBtn onClick={toggleShow}>Launch demo modal</MDBBtn>
<MDBModal tabIndex='-1' show={popoverModal} setShow={setPopoverModal}>
<MDBModalDialog>
<MDBModalContent>
<MDBModalHeader>
<MDBModalTitle>Modal title</MDBModalTitle>
<MDBBtn className='btn-close' color='none' onClick={toggleShow}></MDBBtn>
</MDBModalHeader>
<MDBModalBody>
<h5>Popover in a modal</h5>
<p>
This
<MDBPopover isOpen={popoverModal} color='secondary' btnChildren='button' placement='right'>
<MDBPopoverHeader>Popover title</MDBPopoverHeader>
<MDBPopoverBody>Popover body content is set in this attribute.</MDBPopoverBody>
</MDBPopover>
triggers a popover on click.
</p>
<hr />
<h5>Tooltips in a modal</h5>
<p>
<MDBTooltip tag='a' wrapperProps={{ href: '#!' }} title='Tooltip'>
This link
</MDBTooltip>{' '}
and{' '}
<MDBTooltip tag='a' wrapperProps={{ href: '#!' }} title='Tooltip'>
that link
</MDBTooltip>{' '}
have tooltips on hover.
</p>
</MDBModalBody>
<MDBModalFooter>
<MDBBtn color='secondary' onClick={toggleShow}>
Close
</MDBBtn>
<MDBBtn>Save changes</MDBBtn>
</MDBModalFooter>
</MDBModalContent>
</MDBModalDialog>
</MDBModal>
</>
);
}
Using the grid
Utilize the Bootstrap grid system within a modal by nesting
.container-fluid
within the .modal-body
. Then, use the normal grid
system classes as you would anywhere else.
import React, { useState } from 'react';
import { MDBBtn,
MDBModal,
MDBModalDialog,
MDBModalContent,
MDBModalHeader,
MDBModalTitle,
MDBModalBody,
MDBModalFooter,
} from 'mdb-react-ui-kit';
export default function App() {
const [gridModal, setGridModal] = useState(false);
const toggleShow = () => setGridModal(!gridModal);
return (
<>
<MDBBtn onClick={toggleShow}>Launch demo modal</MDBBtn>
<MDBModal tabIndex='-1' show={gridModal} setShow={setGridModal}>
<MDBModalDialog>
<MDBModalContent>
<MDBModalHeader>
<MDBModalTitle>Grids in modals</MDBModalTitle>
<MDBBtn
type='button'
className='btn-close'
color='none'
onClick={toggleShow}
></MDBBtn>
</MDBModalHeader>
<MDBModalBody>
<div className='container-fluid bd-example-row'>
<div className='row'>
<div className='col-md-4 col-example'>.col-md-4</div>
<div className='col-md-4 ms-auto col-example'>.col-md-4 .ms-auto</div>
</div>
<div className='row'>
<div className='col-md-3 ms-auto col-example'>.col-md-3 .ms-auto</div>
<div className='col-md-2 ms-auto col-example'>.col-md-2 .ms-auto</div>
</div>
<div className='row'>
<div className='col-md-6 ms-auto col-example'>.col-md-6 .ms-auto</div>
</div>
<div className='row'>
<div className='col-sm-9 col-example'>
Level 1: .col-sm-9
<div className='row'>
<div className='col-8 col-sm-6 col-example'>Level 2: .col-8 .col-sm-6</div>
<div className='col-4 col-sm-6 col-example'>Level 2: .col-4 .col-sm-6</div>
</div>
</div>
</div>
</div>
</MDBModalBody>
<MDBModalFooter>
<MDBBtn color='secondary' onClick={toggleShow}>
Close
</MDBBtn>
<MDBBtn>Save changes</MDBBtn>
</MDBModalFooter>
</MDBModalContent>
</MDBModalDialog>
</MDBModal>
</>
);
}
Varying modal content
Have a bunch of buttons that all trigger the same modal with slightly different contents? Use
event.relatedTarget
and
HTML data-mdb-*
attributes
to vary the contents of the modal depending on which button was clicked.
Below is a live demo followed by example HTML and JavaScript. For more information, read the
modal API/events doc for details on relatedTarget
.
import React, { useState } from 'react';
import { MDBBtn,
MDBModal,
MDBModalDialog,
MDBModalContent,
MDBModalHeader,
MDBModalTitle,
MDBModalBody,
MDBModalFooter,
MDBInput,
} from 'mdb-react-ui-kit';
export default function App() {
const [varyingState, setVaryingState] = useState('');
const [varyingModal, setVaryingModal] = useState(false);
const [varyingRecipient, setVaryingRecipient] = useState('');
const [varyingMessage, setVaryingMessage] = useState('');
const onChangeRecipient = (event: any) => {
setVaryingRecipient(event.target.value);
};
const onChangeMessage = (event: any) => {
setVaryingMessage(event.target.value);
};
return (
<>
<MDBBtn
onClick={() => {
setVaryingState('@mdo');
setVaryingModal(!varyingModal);
setVaryingRecipient('@mdo');
}}
>
Open modal for @mdo
</MDBBtn>
<MDBBtn
onClick={() => {
setVaryingState('@fat');
setVaryingModal(!varyingModal);
setVaryingRecipient('@fat');
}}
>
Open modal for @fat
</MDBBtn>
<MDBBtn
onClick={() => {
setVaryingState('@getbootstrap');
setVaryingModal(!varyingModal);
setVaryingRecipient('@getbootstrap');
}}
>
Open modal for @getbootstrap
</MDBBtn>
<MDBModal show={varyingModal} setShow={setVaryingModal} tabIndex='-1'>
<MDBModalDialog>
<MDBModalContent>
<MDBModalHeader>
<MDBModalTitle>New message to {varyingState}</MDBModalTitle>
<MDBBtn className='btn-close' color='none' onClick={() => setVaryingModal(!varyingModal)}></MDBBtn>
</MDBModalHeader>
<MDBModalBody>
<form>
<div className='mb-3'>
{varyingModal && (
<MDBInput
value={varyingRecipient}
onChange={onChangeRecipient}
labelClass='col-form-label'
label='Recipient:'
/>
)}
</div>
<div className='mb-3'>
{varyingModal && (
<MDBInput
value={varyingMessage}
onChange={onChangeMessage}
textarea
labelClass='col-form-label'
label='Message:'
/>
)}
</div>
</form>
</MDBModalBody>
<MDBModalFooter>
<MDBBtn color='secondary' onClick={() => setVaryingModal(!varyingModal)}>
Close
</MDBBtn>
<MDBBtn>Save changes</MDBBtn>
</MDBModalFooter>
</MDBModalContent>
</MDBModalDialog>
</MDBModal>
</>
);
}
Toggle between modals
Toggle between multiple modals with some clever placement of the
data-mdb-target
and data-mdb-toggle
attributes. For example, you
could toggle a password reset modal from within an already open sign in modal.
Please note multiple modals cannot be open at the same time—this method
simply toggles between two separate modals.
Below is a live demo followed by example HTML and JavaScript. For more information, read the
modal API/events doc for details on relatedTarget
.
import React, { useState } from 'react';
import { MDBBtn,
MDBModal,
MDBModalDialog,
MDBModalContent,
MDBModalHeader,
MDBModalTitle,
MDBModalBody,
MDBModalFooter,
} from 'mdb-react-ui-kit';
export default function App() {
const [toggleOneModal, setToggleOneModal] = useState(false);
const [toggleTwoModal, setToggleTwoModal] = useState(false);
return (
<>
<MDBBtn onClick={() => setToggleOneModal(!toggleOneModal)}>OPEN FIRST MODAL</MDBBtn>
<MDBModal show={toggleOneModal} setShow={setToggleOneModal} tabIndex='-1'>
<MDBModalDialog centered>
<MDBModalContent>
<MDBModalHeader>
<MDBModalTitle>Modal 1</MDBModalTitle>
<MDBBtn
className='btn-close'
color='none'
onClick={() => setToggleOneModal(!toggleOneModal)}
></MDBBtn>
</MDBModalHeader>
<MDBModalBody>Show a second modal and hide this one with the button below.</MDBModalBody>
<MDBModalFooter>
<MDBBtn
onClick={() => {
setToggleOneModal(!toggleOneModal);
setTimeout(() => {
setToggleTwoModal(!toggleTwoModal);
}, 400);
}}
>
Open second modal
</MDBBtn>
</MDBModalFooter>
</MDBModalContent>
</MDBModalDialog>
</MDBModal>
<MDBModal show={toggleTwoModal} setShow={setToggleTwoModal} tabIndex='-1'>
<MDBModalDialog centered>
<MDBModalContent>
<MDBModalHeader>
<MDBModalTitle>Modal 2</MDBModalTitle>
<MDBBtn
className='btn-close'
color='none'
onClick={() => setToggleTwoModal(!toggleTwoModal)}
></MDBBtn>
</MDBModalHeader>
<MDBModalBody>Hide this modal and show the first with the button below.</MDBModalBody>
<MDBModalFooter>
<MDBBtn
onClick={() => {
setToggleTwoModal(!toggleTwoModal);
setTimeout(() => {
setToggleOneModal(!toggleOneModal);
}, 400);
}}
>
Back to first
</MDBBtn>
</MDBModalFooter>
</MDBModalContent>
</MDBModalDialog>
</MDBModal>
</>
);
}
Optional sizes
Modals have three optional sizes, available via modifier props to be placed on a MDBModalDialog
.
These sizes kick in at certain breakpoints to avoid horizontal scrollbars on narrower viewports.
Size | Prop | Modal max-width |
---|---|---|
Small | size="sm" |
300px |
Default | None | 500px |
Large | size="lg" |
800px |
Extra large | size="xl" |
1140px |
import React, { useState } from 'react';
import { MDBBtn,
MDBModal,
MDBModalDialog,
MDBModalContent,
MDBModalHeader,
MDBModalTitle,
MDBModalBody
} from 'mdb-react-ui-kit';
export default function App() {
const [optSmModal, setOptSmModal] = useState(false);
const toggleShow = () => setOptSmModal(!optSmModal);
return (
<>
<MDBBtn onClick={toggleShow}>Small modal</MDBBtn>
<MDBModal show={optSmModal} tabIndex='-1' setShow={setOptSmModal}>
<MDBModalDialog size='sm'>
<MDBModalContent>
<MDBModalHeader>
<MDBModalTitle>Small modal</MDBModalTitle>
<MDBBtn className='btn-close' color='none' onClick={toggleShow}></MDBBtn>
</MDBModalHeader>
<MDBModalBody>...</MDBModalBody>
</MDBModalContent>
</MDBModalDialog>
</MDBModal>
</>
);
}
Fullscreen Modal
Another override is the option to pop up a modal that covers the user viewport, available via
modifier props that are placed on a MDBModalDialog
.
Prop | Availability |
---|---|
size="fullscreen" |
Always |
size="fullscreen-sm-down" |
Below 576px |
size="fullscreen-md-down" |
Below 768px |
size="fullscreen-lg-down" |
Below 992px |
size="fullscreen-xl-down" |
Below 1200px |
size="fullscreen-xxl-down" |
Below 1400px |
import React, { useState } from 'react';
import { MDBBtn,
MDBModal,
MDBModalDialog,
MDBModalContent,
MDBModalHeader,
MDBModalTitle,
MDBModalBody,
MDBModalFooter,
} from 'mdb-react-ui-kit';
export default function App() {
const [fullscreenXlModal, setFullscreenXlModal] = useState(false);
const toggleShow = () => setFullscreenXlModal(!fullscreenXlModal);
return (
<>
<MDBBtn onClick={toggleShow}>Full screen below xl</MDBBtn>
<MDBModal tabIndex='-1' show={fullscreenXlModal} setShow={setFullscreenXlModal}>
<MDBModalDialog size='fullscreen-xl-down'>
<MDBModalContent>
<MDBModalHeader>
<MDBModalTitle>Full screen below xl</MDBModalTitle>
<MDBBtn
type='button'
className='btn-close'
color='none'
onClick={toggleShow}
></MDBBtn>
</MDBModalHeader>
<MDBModalBody>...</MDBModalBody>
<MDBModalFooter>
<MDBBtn type='button' color='secondary' onClick={toggleShow}>
Close
</MDBBtn>
</MDBModalFooter>
</MDBModalContent>
</MDBModalDialog>
</MDBModal>
</>
);
}
Modal - API
Import
import {
MDBModal,
MDBModalDialog,
MDBModalContent,
MDBModalHeader,
MDBModalTitle,
MDBModalBody,
MDBModalFooter,
} from 'mdb-react-ui-kit';
Properties
MDBModal
Name | Type | Default | Description | Example |
---|---|---|---|---|
animationDirection
|
String | '' |
Defines animation direction of the modal |
<MDBModal animationDirection="top" />
|
appendToBody
|
Boolean | false |
Appends element to the end of the body |
<MDBModal appendToBody />
|
backdrop
|
Boolean | true |
Sets a backrop for modal |
<MDBModal backdrop={false} />
|
className
|
String | '' |
Add custom class to MDBModal |
<MDBModal className="class" />
|
closeOnEsc
|
Boolean | true |
Allows to close modal on Escape keydown |
<MDBModal closeOnEsc={false} />
|
leaveHiddenModal
|
Boolean | true |
Defines whether the hidden modal stays in VDOM |
<MDBModal leaveHiddenModal={false} />
|
modalRef
|
Reference | '' |
Reference to the modal element |
<MDBModal modalRef={modalReference} />
|
setShow
|
React.SetStateAction | '' |
Allows to pass the setState action to the Modal component which defines if modal is shown or not |
<MDBModal setShow={setExample} />
|
show
|
Boolean | false |
Sets visibility of the modal |
<MDBModal show={true} />
|
staticBackdrop
|
Boolean | false |
Creates static backdrop for the modal |
<MDBModal staticBackdrop />
|
tag
|
String | 'div' |
Defines tag of the MDBModal element |
<MDBModal tag="section" />
|
MDBModalDialog
Name | Type | Default | Description | Example |
---|---|---|---|---|
centered
|
Boolean | false |
Vertically centeres modal dialog window |
<MDBModalDialog centered />
|
className
|
String | '' |
Add custom class to MDBModalDialog |
<MDBModalDialog className="class" />
|
scrollable
|
Boolean | false |
Allows to scroll through long contents with a scrollbar |
<MDBModalDialog scrollable />
|
size
|
String | '' |
Defines the size of MDBModal component. |
<MDBModalDialog size="lg" />
|
tag
|
String | 'div' |
Defines tag of the MDBModalDialog element |
<MDBModalDialog tag="section" />
|
MDBModalContent
Name | Type | Default | Description | Example |
---|---|---|---|---|
className
|
String | '' |
Add custom class to MDBModalContent |
<MDBModalContent className="class" />
|
tag
|
String | 'div' |
Defines tag of the MDBModalContent element |
<MDBModalContent tag="section" />
|
MDBModalHeader
Name | Type | Default | Description | Example |
---|---|---|---|---|
className
|
String | '' |
Add custom class to MDBModalHeader |
<MDBModalHeader className="class" />
|
tag
|
String | 'div' |
Defines tag of the MDBModalHeader element |
<MDBModalHeader tag="section" />
|
MDBModalTitle
Name | Type | Default | Description | Example |
---|---|---|---|---|
className
|
String | '' |
Add custom class to MDBModalTitle |
<MDBModalTitle className="class" />
|
tag
|
String | 'h5' |
Defines tag of the MDBModalTitle element |
<MDBModalTitle tag="h3" />
|
MDBModalBody
Name | Type | Default | Description | Example |
---|---|---|---|---|
className
|
String | '' |
Add custom class to MDBModalBody |
<MDBModalBody className="class" />
|
tag
|
String | 'div' |
Defines tag of the MDBModalBody element |
<MDBModalBody tag="section" />
|
Events
Name | Type | Description |
---|---|---|
onHide
|
() => any |
This event is fired immediately when the onHide instance method has
been called.
|
onHidePrevented
|
() => any | This event is fired when the modal is shown, its backdrop is static and a click outside the modal or an escape key press is performed with the keyboard option. |
onShow
|
() => any |
This event fires immediately when the onShow instance method is called.
|